mod Ul03 logic: 'cl'

loc rem 
  \para \bf  PREMIOVA ULOHA Z PREDMETU 1-AIN-470 SPECIFIKACIA A VERIFIKACIA 
  PROGRAMOV  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.19 
  \para* \it  Datum:  \end stvrtok 2.4.2009 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-470-svp/0809ls/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

loc rem 
  \para \bf  Hodnotenie.  \end 
  \items 
   \item \para Pocet bodov za ulohu: \bf  \it  2  \end  \end. 
   \item \para Hodnoti sa len kompletne vyriesena uloha. 
   \item \para Ulohy rieste \bf  \it  samostatne!  \end  \end 
  \end
  \para Ulohu treba odovzdat do 15.4.2009 (streda) do 12:00. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  [CL] CL-TeX.  \end 

appldisp/2 Tex_f2_n_min
  Std('min',0)

appldisp/2 Tex_f2_n_max
  Std('max',0)

appldisp/1 Tex_f1_f
  Std('f',0)

rem 
  \para \bf  Chapter. Numeric Programs.  \end 

rem 
  \para \bf  Section. Explicit Definitions.  \end 

rem 
  \para \bf  Minimum and maximum.  \end 

fun/2 Min 'Tex_f2_n_min'
  Min(x,y) = x <- x <= y
  Min(x,y) = y <- x > y

fun/2 Max 'Tex_f2_n_max'
  Max(x,y) = x <- x >= y
  Max(x,y) = y <- x < y

thm Spec_min
  Min(x,y) <= x & Min(x,y) <= y & (Min(x,y) = x \/ Min(x,y) = y)
proof 
 case Dich; x,y @ x1,y1; x1,y1
  proved
  proved..

thm Spec_max
  Max(x,y) >= x & Max(x,y) >= y & (Max(x,y) = x \/ Max(x,y) = y)
proof 
 case Dich; y,x @ x1,y1; x1,y1
  proved
  proved..

rem 
  \para \bf  Chapter. Programs Operating on Lists.  \end 

rem 
  \para \bf  Section. Operations on Lists.  \end 

rem 
  \para \bf  Minimum and maximum of lists.  \end 

fun Mm 'Tex_f1_f'
  Mm(v,0) = v,v
  Mm(v,w) = Min(v,y),Max(v,z) <- w != 0 & Mm(w) = y,z

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    x != 0 -> \e y\e z Mm(x) = y,z
  \end
  \eq* 
    x != 0 & Mm(x) = y,z -> y in x & z in x
  \end
  \eq* 
    x != 0 & Mm(x) = y,z & a in x -> y <= a & a <= z
  \end

thm Mm_output
  x != 0 -> \e y\e z Mm(x) = y,z

thm Mm_in
  x != 0 & Mm(x) = y,z -> y in x & z in x

thm Mm_minmax
  x != 0 & Mm(x) = y,z & a in x -> y <= a & a <= z

